﻿namespace Ozeki
{
    internal record ProgressBar(string Filename, OzHfDownloadProgressStatus Action, OzHfIOPerformanceEstimation? Estimation)
    {
        readonly char[] progressChars = [' ', '-', '+', '#'];
        private string drawProgressBar()
        {
            string s = string.Empty;
            int calc = 0;
            if (Estimation != null)
            {
                calc = Estimation.ProgressPercentage;
            }
            for (int i = 0; i < 25; i++)
            {
                if (calc > progressChars.Length - 1)
                {
                    s += progressChars[progressChars.Length - 1];
                    calc -= progressChars.Length;
                }
                else
                {
                    s += progressChars[0];
                    calc = 0;
                }
            }
            return s;
        }
        public override string ToString()
        {
            if(Estimation == null)
            {
                return $"{Action} {Filename}";
            }
            return $"{Action} [{drawProgressBar()}] {Estimation.ProgressPercentage}%  {Estimation.DownloadSpeedToString()} ETA:{Estimation.ETAToString()} {Filename}";
        }
    }
}
